<template>
  <div class="app-container" ref="appContainer">
    <PropTable :loading="loading" @selection-change="selectionChange" :columns="column" :data="list" @reset="reset"
      @onSubmit="onSubmit">
      <template v-slot:btn>
        <div style="display: flex; justify-content: flex-end">
          <el-button type="primary" @click="importByExcel"><el-icon>
            <Upload />
          </el-icon>导入</el-button>
          <el-button type="primary" @click="add"
          ><el-icon><plus /></el-icon> 添加</el-button>
          <el-button type="danger" @click="batchDelete"><el-icon>
              <delete />
            </el-icon>删除</el-button>
        </div>
      </template>
      <template v-slot:type="scope">{{ getTypeLabel(scope.row.type) }}</template>
      <template v-slot:group="scope">{{ getGroupLabel(scope.row.group) }}</template>
      <template v-slot:createTime="scope">{{ dateUtils.getDate(scope.row.createTime) }}</template>
      <template v-slot:operation="scope">
        <el-button type="primary" size="small" icon="Edit" @click="edit(scope.row)">
          编辑
        </el-button>
        <el-button @click="del(scope.row)" type="danger" size="small" icon="Delete">
          删除
        </el-button>
      </template>
    </PropTable>

    <el-dialog v-model="dialogVisible" :title='title' width="50%">
      <el-form ref="ruleFormRef" :model="ruleForm" :rules="rules" label-width="120px" class="demo-ruleForm"
        :size="formSize">
        <el-form-item label="白名单值" prop="value">
          <el-input v-model="ruleForm.value" />
        </el-form-item>
        <el-form-item label="白名单值类型" prop="type">
          <el-radio-group v-model="ruleForm.type">
            <el-radio :label="0">IP</el-radio>
            <el-radio :label="1">账号</el-radio>
            <el-radio :label="2">角色</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="白名单分组" prop="group">
          <el-radio-group v-model="ruleForm.group">
            <el-radio :label="0">程序</el-radio>
            <el-radio :label="1">策划</el-radio>
            <el-radio :label="2">测试</el-radio>
            <el-radio :label="3">运营</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="dialogVisible = false">取消</el-button>
          <el-button type="primary" @click="handleClose(ruleFormRef)">确定</el-button>
        </span>
      </template>
    </el-dialog>

    <el-dialog v-model="importVisible" :title='title' width="70%" @close="importClose">
      <PageWrapLayout class="m-upload-excel">
        <el-upload style="width: 100%" ref="upload" class="upload-demo" drag action="/" :before-upload="beforeUploadAction" type="file"
          accept=".xlsx, .xls" :limit="1" :on-remove="handleRemove">
          <el-icon class="el-icon--upload"><upload-filled /></el-icon>
          <div class="el-upload__text"> 拖拽上传 <em>或者点击上传 Excel</em> </div>
        </el-upload>
        <div>
          <el-table :data="tableData" border highlight-current-row style="width: 100%; margin-top: 20px">
            <el-table-column v-for="item of tableHeader" :prop="item.value" :label="item.label" :key="item">
            </el-table-column>
          </el-table>
        </div>
      </PageWrapLayout>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="importClose">取消</el-button>
          <el-button type="primary" @click="handleConfirm">确定</el-button>
        </span>
      </template>
    </el-dialog>

  </div>
</template>
<script lang="ts" setup name="comprehensive">
import { ref, reactive, onMounted, nextTick, onBeforeMount } from 'vue'
import * as dayjs from 'dayjs'
import { ElMessage, ElMessageBox } from 'element-plus'
import type { FormInstance } from 'element-plus'
const loading = ref(true)
const appContainer = ref(null)
import PropTable from '@/components/Table/PropTable/index.vue'
import dateUtils from '@/common/dateUtils'
import whiteListApi from '@/api/whiteList'

import ExcelJS from 'exceljs'
import { UploadFilled } from '@element-plus/icons-vue'
import type { UploadProps, UploadInstance } from 'element-plus'
// import { ElMessage } from 'element-plus'
const tableData = ref([])
const tableHeader = ref([])
const upload = ref<UploadInstance>()

const tableColumn = ["value","type","group"]
const beforeUploadAction = (file, fileLi) => {
  return new Promise((resolve, reject) => {
    const reader = new FileReader()
    reader.onload = async (e) => {
      const data = e.target.result
      const workbook = new ExcelJS.Workbook()
      try {
        let res = await workbook.xlsx.load(data)
        const sheets =
          res._worksheets && res._worksheets.filter((item) => typeof item !== 'undefined')
        const table = []
        let headers = []
        sheets.forEach((sheet) => {
          sheet._rows.forEach((row, index) => {
            if (index === 0) {
              row.values.forEach((it, i) => {
                headers.push({label: it, value: tableColumn[i - 1]})
              })
            } else {
              let obj = {}
              let arr = []
              row.values.forEach((it) => {
                arr.push(it)
              })
              tableColumn.forEach((ite, i) => {
                if (arr[i] == undefined)  {
                  obj[ite] = null
                } else {
                  obj[ite] = arr[i]
                }
              })
              table.push(obj)
            }
            // const tableRow = {
            //   position: "",
            //   val: "",
            // };
            // row._cells.forEach((cell) => {
            //   tableRow.position = cell._address;
            //   tableRow.val = cell._value.model.value || "";
            // });
          })
        })
        tableData.value = table
        tableHeader.value = headers
        console.log("table", table)
        console.log("headers", headers)
      } catch (e) {
        ElMessage.error('解析失败')
      }
    }
    reader.readAsArrayBuffer(file)
  })
}

const handleRemove: UploadProps['onRemove'] = (uploadFile, uploadFiles) => {
  tableData.value = null
  tableHeader.value = null
}

// const data = []
// for (let i = 0; i < 100; i++) {
//   data.push({
//     id: i + 1,
//     type: i % 3,
//     value: '127.0.0.1',
//   })
// }

const data = ref([])
let currPageNum = 1;
const pageSize = 1000;
onBeforeMount(() => {
  loadWhiteListInfo()
})

const loadWhiteListInfo = () => {
  let queryParams = reactive({
    pageNum: currPageNum,
    pageSize: pageSize
  })
  whiteListApi.query(queryParams).then(res => {
    data.value = res.data.result;
    console.log(data)
  })
}

const column = [
  { type: 'selection', width: 60, fixed: 'left' },
  { name: 'value', label: '白名单值', inSearch: true, valueType: 'input'},
  {
    name: 'type',
    label: '白名单值类型',
    slot: true,
    inSearch: true,
    options: [
      {
        value: 0,
        label: 'IP',
      },
      {
        value: 1,
        label: '账号',
      },
      {
        value: 2,
        label: '角色',
      }
    ],
    valueType: 'select',
  },
  {
    name: 'group',
    label: '白名单分组',
    slot: true,
    inSearch: true,
    options: [
      {
        value: 0,
        label: '程序',
      },
      {
        value: 1,
        label: '策划',
      },
      {
        value: 2,
        label: '测试',
      },
      {
        value: 3,
        label: '运营',
      }
    ],
    valueType: 'select',
  },
  { name: 'createTime', label: '白名单创建时间', slot: true },
  { name: 'operation', slot: true, fixed: 'right', width: 200, label: '操作' },
]

const getTypeLabel = (val) => {
  if (val == 0) {
    return 'IP'
  } else if (val == 1) {
    return '账号'
  } else if (val == 2) {
    return '测试'
  }
}

const getGroupLabel = (val) => {
  if (val == 0) {
    return '程序'
  } else if (val == 1) {
    return '策划'
  } else if (val == 2) {
    return '测试'
  } else if (val == 3) {
    return '运营'
  }
}

const list = ref(data)

const formSize = ref('default')
const ruleFormRef = ref<FormInstance>()
const ruleForm = reactive({
  value: null,
  type: null,
  group: null
})

const rules = reactive({
  value: [
    {
      required: true,
      message: '请输入白名单值',
      trigger: 'change',
    },
  ],
  type: [
    {
      required: true,
      message: '请选择白名单值类型',
      trigger: 'change',
    },
  ],
  group: [
    {
      required: true,
      message: '请选择白名单分组',
      trigger: 'change',
    },
  ],
})

const dialogVisible = ref(false)
const importVisible = ref(false)
const rowObj = ref({})
const selectObj = ref([])
const title = ref('编辑')

const importClose = () => {
  importVisible.value = false
  upload.value!.clearFiles()
  tableData.value = null
  tableHeader.value = null
}

const importByExcel = () => {
  title.value = '导入'
  importVisible.value = true
  tableData.value = null
  tableHeader.value = null
}

const add = () => {
  title.value = '新增'
  dialogVisible.value = true
  ruleForm.value = null
  ruleForm.type = null
}

const handleConfirm = () => {
  // 验证table数据
  // ...
  let importParams = reactive({
    importValue: tableData.value
  })
  whiteListApi.importBatch(importParams).then(res => {
    console.log('result', res)
    if (res.data.code = 200) {
      loadWhiteListInfo
      importVisible.value = false
      return ElMessage.success(res.data.msg)
    } else {
      return ElMessage.error(res.data.msg)
    }
  })
  console.log('import submit!')
}

const handleClose = async (done: () => void) => {
  await ruleFormRef.value.validate((valid, fields) => {
    if (valid) {
      if (title.value == '新增') {
        whiteListApi.add(ruleForm).then(res => {
          console.log('result', res)
          if (res.data.code = 200) {
            loadWhiteListInfo()
            dialogVisible.value = false
            return ElMessage.success(res.data.msg)
          } else {
            return ElMessage.error(res.data.msg)
          }
        })
        console.log('add submit!')
      } else {
        // let updateParams = reactive({
        //   value: rowObj.value,
        //   updateValue: ruleForm
        // })
        whiteListApi.update(ruleForm).then(res => {
          if (res.data.code = 200) {
            loadWhiteListInfo()
            dialogVisible.value = false
            return ElMessage.success('修改成功')
          } else {
            return ElMessage.error('修改失败')
          }
        })
        console.log('update submit!')
      }
      console.log('submit!', ruleForm)
    } else {
      console.log('error submit!', fields)
    }
  })
}

const batchDelete = () => {
  if (!selectObj.value.length) {
    return ElMessage.error('未选中任何行')
  }
  ElMessageBox.confirm('你确定要删除选中项吗?', '温馨提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
    draggable: true,
  })
    .then(() => {
      let whiteListValues = reactive([])
      for (let value of selectObj.value) {
        whiteListValues.push(value.value)
      }
      let deleteParams = reactive({
        values: whiteListValues
      })
      whiteListApi.deleteBatch(deleteParams).then(res => {
        loadWhiteListInfo()
        ElMessage.success('批量删除成功')
      })

      list.value = list.value.concat([])
    })
    .catch(() => { })
}
const selectionChange = (val) => {
  selectObj.value = val
}

const edit = (row) => {
  rowObj.value = row
  dialogVisible.value = true
  ruleForm.type = row.type
  ruleForm.value = row.value
  ruleForm.group = row.group
}

const del = (row) => {
  console.log('row==', row)
  ElMessageBox.confirm('你确定要删除当前项吗?', '温馨提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
    draggable: true,
  })
    .then(() => {
      let deleteParams = reactive({
        value: row.value
      })
      whiteListApi.delete(deleteParams).then(res => {
        loadWhiteListInfo()
        ElMessage.success('删除成功')
      })
      loading.value = true
      setTimeout(() => {
        loading.value = false
      }, 500)
    })
    .catch(() => { })
}

const reset = () => {
  loadWhiteListInfo()
  loading.value = true
  setTimeout(() => {
    loading.value = false
  }, 500)
  ElMessage.success('重置成功')
}

const onSubmit = (val) => {
  if ((val.value == null || val.value == "") && val.type == null && val.group == null) {
    ElMessage.warning('请输入查询条件')
    return
  }
  let queryParams = reactive({
    pageNum: 1,
    pageSize: pageSize,
    condition: val
  })
  whiteListApi.query(queryParams).then(res => {
    data.value = res.data.result;
    console.log(data.value)
  })
  loading.value = true
  setTimeout(() => {
    loading.value = false
  }, 500)
}

const getHeight = () => {

}

onMounted(() => {
  nextTick(() => {
    // let data = appContainer.value.
  })
  setTimeout(() => {
    loading.value = false
  }, 500)
})
</script>

<style scoped>
.edit-input {
  padding-right: 100px;
}

.app-container {
  flex: 1;
  display: flex;
  width: 100%;
  padding: 16px;
  box-sizing: border-box;
}

.cancel-btn {
  position: absolute;
  right: 15px;
  top: 10px;
}
</style>
